/*
 *                         'trinity.h'
  *            This file is part of the "trinity" project.
 *               (https://github.com/hobywan/trinity)
 *                Copyright 2016, Hoby Rakotoarivelo
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#pragma once
/* -------------------------------------------------------------------------- */

#include "trinity/tools.h"
#include "trinity/timer.h"
#include "trinity/sync.h"
#include "trinity/parser.h"
#include "trinity/hashtable.h"
#include "trinity/rmat.h"
#include "trinity/io.h"
#include "trinity/mesh.h"
#include "trinity/hessian.h"
#include "trinity/numeric.h"
#include "trinity/metric.h"
#include "trinity/partition.h"
#include "trinity/matching.h"
#include "trinity/refinement.h"
#include "trinity/coarsening.h"
#include "trinity/smoothing.h"
#include "trinity/swapping.h"
/* -------------------------------------------------------------------------- */
